unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ppCtrls, ppPrnabl, ppClass, ppBands, daDataView,
  daQueryDataView, daDBBDE, ppModule, daDataModule, ppCache, ppComm,
  ppRelatv, ppProd, ppReport,
  ppDevice, StdCtrls;

type
  TForm1 = class(TForm)
    ppReport1: TppReport;
    ppHeaderBand1: TppHeaderBand;
    ppDetailBand1: TppDetailBand;
    ppFooterBand1: TppFooterBand;
    daDataModule1: TdaDataModule;
    daBDEQueryDataView1: TdaBDEQueryDataView;
    ppColumnHeaderBand1: TppColumnHeaderBand;
    ppColumnFooterBand1: TppColumnFooterBand;
    ppGroup1: TppGroup;
    ppGroupHeaderBand1: TppGroupHeaderBand;
    ppGroupFooterBand1: TppGroupFooterBand;
    ppDBText1: TppDBText;
    ppDBText2: TppDBText;
    ppDBCalc1: TppDBCalc;
    ppShape1: TppShape;
    ppLabel1: TppLabel;
    Button1: TButton;
    procedure ppReport1StartPage(Sender: TObject);
    procedure ppReport1EndPage(Sender: TObject);
    procedure GroupFooterDrawCommandCreate(Sender, aDrawCommand: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private

  public
    FFooter1DrawCommands: TList;
    FFooter2DrawCommands: TList;

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  FFooter1DrawCommands := TList.Create;
  FFooter2DrawCommands := TList.Create;

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FFooter1DrawCommands.Free;
  FFooter2DrawCommands.Free;

end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  ppReport1.Print;
end;

procedure TForm1.ppReport1StartPage(Sender: TObject);
begin

  // clear the draw command lists
  FFooter1DrawCommands.Clear;
  FFooter2DrawCommands.Clear;

end;

procedure TForm1.ppReport1EndPage(Sender: TObject);
var
  liIndex: Integer;
  lDrawCommand1: TppDrawCommand;
  lDrawCommand2: TppDrawCommand;
begin

  // align group footer draw commands
  for liIndex := 0 to FFooter1DrawCommands.Count-1 do
    begin
      lDrawCommand1 := TppDrawCommand(FFooter1DrawCommands[liIndex]);
      lDrawCommand2 := TppDrawCommand(FFooter2DrawCommands[liIndex]);

      // adjust to max top
      if lDrawCommand1.Top > lDrawCommand2.Top then
        lDrawCommand2.Top := lDrawCommand1.Top
      else
        lDrawCommand1.Top := lDrawCommand2.Top;

    end;

end;

procedure TForm1.GroupFooterDrawCommandCreate(Sender, aDrawCommand: TObject);
begin

  // this event-handler is assigned to the OnDrawCommandCreate event of each
  //  object in the group footer band

  // the event fires each time an object prints on a page. The aDrawCommand
  // parameter contains a TppDrawCommand descendant generated by the
  // Label, Shape, or DBText

  if ppReport1.CurrentColumn = 1 then
    FFooter1DrawCommands.Add(aDrawCommand)
  else
    FFooter2DrawCommands.Add(aDrawCommand)

end;



end.
